//+------------------------------------------------------------------+
//|                                                       WPR-v3.mq4 |
//|                                    Copyright 2013, Ando Masahiro |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Ando Masahiro"
#property link      "http://ameblo.jp/tidy01/"

//--- input parameters
extern int       U_Level=-10;
extern int       L_Level=-90;
extern double    Lots= 2.7;
extern double  MaxLots=2.7;
extern double  MinLots=0.01;
extern int       SL=1000;
extern int       TP=600;
extern int       M = 32;
extern int       magic=22226;
extern int       WPRPeriod = 14;
extern int slippage = 3;

extern double nampin=60;
extern int maxnampin=6;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int sell;
   int buy;

	int cnt;
	int CurrentPosition;
	int Ticket;
	double profit;

	double WPR = iWPR(NULL, 0, WPRPeriod, 0);
	double WPR1= iWPR(NULL, 0, WPRPeriod, 1);
	CurrentPosition=-1;
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
		if(OrderSelect(cnt,SELECT_BY_POS)==false)continue;
		if(OrderMagicNumber()!=magic)continue;
		profit=profit+OrderProfit();
		if(OrderMagicNumber()==magic)CurrentPosition=cnt;
	}
	if(Lots > MaxLots)
		Lots = MaxLots;
	if(Lots < MinLots)
		Lots = MinLots;
		
	if( (WPR > U_Level) && (WPR1 < U_Level) ) 
   		buy = 1;
	else if((WPR < L_Level) && (WPR1 > L_Level))  
			sell = 1;
	if(CurrentPosition==-1)
	{
		if(buy==1)
		{
			Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Ask-(SL*Point),Ask+(TP*Point), "BUY", magic, 0, Red);
		}
		else if(sell == 1)
		{
		    Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3,Bid+(SL*Point),Bid-(TP*Point), "SELL", magic, 0, Blue);
		}
	}
	else
	{
		OrderSelect(CurrentPosition,SELECT_BY_POS);
		if(OrderSymbol()==Symbol())
		{
			if(OrderType()==OP_BUY)
			{
			      
				if((OrdersTotal()<(maxnampin+1))&&(Close[0]<(OrderOpenPrice()-nampin*Point)))
				{
					Ticket=OrderSend(Symbol(),OP_BUY,(OrderLots()*2),Ask,slippage,Ask-(SL*Point),Ask+(TP*Point),"buy2",magic,0,Blue);
				}
				if(profit>TP*M)
				{
					allClose(Green);
				}
			}
			
			if(OrderType()==OP_SELL)
			{			      
				if((OrdersTotal()<(maxnampin+1))&& (Close[0]>(OrderOpenPrice()+nampin*Point)))
				{
					Ticket=OrderSend(Symbol(),OP_SELL,(OrderLots()*2),Bid,slippage,Bid+(SL*Point),Bid-(TP*Point),"sell2",magic,0,Red);
				}
				if(profit>TP*M)
				{
					allClose(Yellow);
				}
			}
		}
		
	}
//----
   return(0);
  }
  
void allClose(color clr)
{
	int i;
	for(i=OrdersTotal()-1;i>=0;i--)
	{
		if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)
			continue;
		if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=magic)
			continue;
		if(OrderType()==OP_BUY)
			OrderClose(OrderTicket(),OrderLots(),Bid,NormalizeDouble(slippage,0),clr);
		if(OrderType()==OP_SELL)
			OrderClose(OrderTicket(),OrderLots(),Ask,NormalizeDouble(slippage,0),clr);
	}
}

//+------------------------------------------------------------------+